#include "Node.h"

// Neuen Knoten erzeugen
node *make_node(int id, char name[])
{
  node *nd = (node *)malloc(sizeof(node));
  nd->id = id;
  strncpy(nd->name, name, sizeof(nd->name));
  nd->left  = NULL;
  nd->right = NULL;

  return nd;
}

// Knoten ND in Baum ROOT einfuegen
void insert_node(node *root, node *nd)
{
  if (nd->id < root->id)
  {
    if (root->left == NULL)
      root->left = nd;
    else
      insert_node(root->left, nd);
  }
  else if (nd->id > root->id)
  {
    if (root->right == NULL)
      root->right = nd;
    else
      insert_node(root->right, nd);
  }
  else
  {
    // Duplicate
    abort();
  }
}

// Knoten mit Kennung ID in Baum ROOT zurueckgeben (wenn nicht gefunden, NULL)
node *find_node(node *root, int id)
{
  if (id == root->id)
    return root;
  if (id < root->id && root->left != NULL)
    return find_node(root->left, id);
  if (id > root->id && root->right != NULL)
    return find_node(root->right, id);
  return NULL;
}

// Suchbaum mit Beispiel-Datensaetzen fuellen
node *create_tree()
{
  node *root = make_node(70970, "Zeller");
  insert_node(root, make_node(54599, "Mueller"));
  insert_node(root, make_node(80934, "Podolski"));
  insert_node(root, make_node(31536, "Rahn"));
  insert_node(root, make_node(75636, "Prinz"));
  insert_node(root, make_node(98639, "Oezil"));
  return root;
}

// Suchbaum wieder freigeben
void free_tree(node *root)
{
  if (root->left != NULL)
    free_tree(root->left);
  if (root->right != NULL)
    free_tree(root->right);
  free(root);
}

void print_node(node *node)
{
    Serial.print(node->id);
    Serial.print(" ");
    Serial.println(node->name);

    // printf("%d %s\n", node->id, node->name);
}

void setup() {
  // put your setup code here, to run once:
  node *tree = create_tree();
  
  node *rahn = find_node(tree, 31536);
  print_node(rahn);

  free_tree(tree);
}

void loop() {
  // put your main code here, to run repeatedly: 
  
}

// int main(int argc, char *argv[])
// {
//     setup();
// }
